[PACKAGE]: ../../raw/master/squid-2.0.4-2023-09-21.mkp "squid-2.0.4-2023-09-21.mkp"
# Squid Web Proxy

This CheckMK plugin monitors the performance of the _**Squid Web Proxy**_. This plugin is intended to use with the Agent Bakery of CheckMK.

### Acnowlegement

This plugin is based on the work of Allan GooD: allan[dot]cassaro[at]gmail[dot]com. See https://github.com/allangood/check_mk/tree/master/plugins/squid for more details.

---
### Download

* [squid.mkp (latest version)](https://thl-cmk.hopto.org/gitlab/checkmk/various/squid/-/raw/master/squid.mkp "Download latest version")
                        
---
### Installation

You can install the package by uploading it to your CheckMK site and as site user run 
```
mkp install squid.mkp
mkp enable squid VERSION
```

In the Enterprise/Free/Cloud edition of CheckMK you can use the GUI to install the package (_Setup_ -> _Extension Packages_ -> _Upload package_)

If you are not using the Agent Bakery, you need to copy the `squid` agent plugin from `~/local/share/check_mk/agents/plugins/squid` of your CheckMK site to the check_mk agent path of your Squid server. This is usually `/usr/lib/check_mk_agent/plugins/` (Don't forget to make it executable). 

**Note**: The agent plugin requieres the **squidclient** package to be installed in addition to the _**Squid Web Proxy**_.

---
### Want to Contribute?

Nice ;-) Have a look at the [contribution guidelines](CONTRIBUTING.md "Contributing")

---
### Check Info

The plugin creates the service **_Squid_** the items _**Client**_, _**Server**_, _**CPU**_ and _**DNS**_.

<details><summary>Montoring states</summary>

| State     | Counter           | condition     | WATO   |
| -----     | -----             |------         | ------ |
| WARN/CRIT | Client Requests   | not in levels | yes    |
| WARN/CRIT | Client Hits       | not in levels | yes    |
| WARN/CRIT | Server Requests   | not in levels | yes    |
| WARN/CRIT | CPU Usage         | not in levels | yes    |
| WARN/CRIT | DNS response time | not in levels | yes    |

</details>

<details><summary>Perfdata</summary>

| Metric              | Unit    | Perfometer |
| ------              | ------  | ------     |
| Client requests     | 1/s     | no         |
| Client errors       | 1/s     | no         |
| Client hits         | 1/s     | no         |
| Client bytes in/out | bit/s   | yes        |
| Server requests     | 1/s     | no         |
| Server errors       | 1/s     | no         |
| Server bytes in/out | bit/s   | yes        |
| CPU utilization     | %       | yes        |
| CPU time            | seconds | no         |
| DNS response time   | seconds | yes        |

</details>

---
### WATO
<details><summary>Service monitoring rule</summary>

| Section                            | Rule name       |
| ------                             | ------          |
| Applications, Processes & Services | Squid Web Proxy |

| Option                           | Defailt value | Predictive | 
| ------                           | ------        | ---------- |
| Set levels for Client Requests   | none          | optional   |
| Set levels for Client Hits       | none          | optional   |
| Set levels for Server Requests   | none          | optional   |
| Set levels for Squid CPU usage   | 60.0/80.0     | optional   |
| Set levels for DNS response time | 2.0/4.0       | no         |

</details> 

<details><summary>Bakery rule</summary>

| Section     | Rule name               |
| ------      | ------                  |
| Agent rules | Squid Web Proxy (Linux) |

| Option      | Defailt value |
| ------      | ------        |
| Port number | 3128          |

</details> 

---
### Sample Output

Sample output

![sample output](/doc/sample.png?raw=true "sample output")
